<!DOCTYPE html>
<html lang="en">

<head>
    <title>OrderDetail</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPaging()">
    <div class="container">
        <div class="form-group">
            <p class="h3 text-left mt-5">OrderDetail!!! </p>
        </div>
        <div class="form-group">
            <label>Order Code(mã đơn hàng):</label>
            <input class="form-control" id="inp-ma-don-hang">
        </div>
        <div class="form-group">
            <label>Cỡ combo:</label>
            <select id="select-size" class="form-control">
                <option value='NOT-SELECT-COMBO'>Chọn cỡ Combo (Combo size)</option>
                <option value="S">Nhỏ</option>
                <option value="M">Vừa</option>
                <option value="L">Lớn</option>
            </select>
        </div>
        <div class="form-group">
            <label>Đường kính</label>
            <input class="form-control" id="inp-size" type="text">
        </div>
        <div class="form-group">
            <label>Sườn nướng</label>
            <input class="form-control" id="inp-suon-nuong" type="text">
        </div>
        <div class="form-group">
            <label>Đồ uống</label>
            <select id="select-drink" class="form-control">
                <option value='NOT-SELECT-DRINK'>Chọn Đồ uống</option>
            </select>
        </div>
        <div class="form-group">
            <label>Số lượng nước uống</label>
            <input class="form-control" id="inp-so-luong-nuoc">
        </div>
        <div class="form-group">
            <label>Voucher ID</label>
            <input class="form-control" id="input-voucher">
        </div>
        <div class="form-group">
            <label>Loại pizza</label>
            <select id="select-pizza" class="form-control">
                <option value='NOT-SELECT-PIZZA'>Chọn loại pizza</option>
                <option value="Ga">Gà</option>
                <option value="HaiSan">Hải sản</option>
                <option value="Bacon">Thịt Nướng</option>
            </select>
        </div>
        <div class="form-group">
            <label>Salad</label>
            <input class="form-control" id="inp-salad" type="text">
        </div>
        <div class="form-group">
            <label>Thành tiền</label>
            <input class="form-control" id="inp-price">
        </div>
        <div class="form-group">
            <label>Giảm giá</label>
            <input class="form-control" id="inp-giam-gia" type="text">
        </div>
        <div class="form-group">
            <label>Họ và tên</label>
            <input class="form-control" id="input-ho-ten" type="text">
        </div>
        <div class="form-group">
            <label>Email</label>
            <input class="form-control" id="inp-email" type="text">
        </div>
        <div class="form-group">
            <label>Số điện thoại</label>
            <input class="form-control" id="inp-mobile" type="text">
        </div>
        <div class="form-group">
            <label>Địa chỉ</label>
            <input class="form-control" id="inp-address" type="text">
        </div>
        <div class="form-group">
            <label>Lời nhắn</label>
            <input class="form-control" id="input-message" type="text">
        </div>
        <div class="form-group">
            <label>Trạng thái đơn hàng</label>
            <input class="form-control" id="inp-status" type="text">
        </div>
        <div class="form-group">
            <label>Ngày tạo đơn</label>
            <input class="form-control" id="inp-date" type="text">
        </div>
        <div class="form-group">
            <label>Ngày cập nhật</label>
            <input class="form-control" id="inp-date-update" type="text">
        </div>
        <div class="form-group">
            <button class="btn btn-gruop btn-primary" id="btn-confirm" onclick="onBtnConfirmClick()">Confirm</button>
            <button class="btn btn-gruop btn-info" id="btn-cancel" onclick="onBtnCancelClick()">Cancel</button>
            <li class="nav-item text-right">
                <a href="ListOrder.html">Quay lại</a>
            </li>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm load dữ liệu
    function onPaging() {
        "use strict";
        // b1: đọc dữ liệu (không có)
        var vUrlString = window.location.href  // Đường dẫn gọi đến trang
        var vUrlObject = new URL(vUrlString); // Tạo đối tượng url để truy vấn tham số
        // Truy vấn
        var vOderCode = vUrlObject.searchParams.get("orderCode");
        var vId = vUrlObject.searchParams.get("id");
        // b2: validate
        const vFORM_LIST_VIEW = "listOrder.html";
        if (vId == null || vId == "") {
            alert("Không có id đơn hàng");
            window.location.href = vFORM_LIST_VIEW;
        }
        else if (vOderCode == null || vOderCode == "") {
            alert("Không có orderCode");
            window.location.href = vFORM_LIST_VIEW;
        }
        console.log("OrderCode:" + vOderCode);
        console.log("Id:" + vId);
        // Load dữ liệu vào select drink
        //loadDataDrinkList();
        // b3: gọi sever
        var vXmlHttpGetOrder = new XMLHttpRequest(); // Tạo đối tượng XMLHttpRequest
        goiApiObject(vXmlHttpGetOrder, vOderCode);
        vXmlHttpGetOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // b4: Hiển thị dữ liệu
                    hienThiDuLieuOject(vXmlHttpGetOrder);
                }
            }
    }
    // Hàm xử lí sự kiện khi ấn nút confirm
    function onBtnConfirmClick() {
        var vUrlString = window.location.href  // Đường dẫn gọi đến trang
        var vUrlObject = new URL(vUrlString); // Tạo đối tượng url để truy vấn tham số
        // Truy vấn
        var vId = vUrlObject.searchParams.get("id");
        console.log("Id của oder là:" + vId);
        // Đối tượng trạng thái
        var vObject = {
            trangThai: "confirmed",
        }
        // b1: thu thập dữ liệu (không có)

        // b2: kiểm tra dữ liệu (không có)
        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        // b3: call apie
        callApiUpdateOder(vXmlHttpUpdateOrder, vObject, vId);
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // b4: hiển thị dữ liệu
                    hienThiDuLieuObject(vXmlHttpUpdateOrder);
                }
            }
    }
    function onBtnCancelClick() {
        var vUrlString = window.location.href  // Đường dẫn gọi đến trang
        var vUrlObject = new URL(vUrlString); // Tạo đối tượng url để truy vấn tham số
        // Truy vấn
        var vId = vUrlObject.searchParams.get("id");
        console.log("Id của oder là:" + vId);
        // Đối tượng trạng thái
        var vObject = {
            trangThai: "cancel",
        }
        // b1: thu thập dữ liệu (không có)

        // b2: kiểm tra dữ liệu (không có)
        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        // b3: call api
        callApiCancelOder(vXmlHttpUpdateOrder, vObject, vId);
        vXmlHttpUpdateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // b4: hiển thị dữ liệu
                    hienThiDuLieuObjectToCancel(vXmlHttpUpdateOrder);
                }
            }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện Call aoi để update đơn hàng
    function callApiUpdateOder(paramXlmhttp, paramObject, paramId) {
        paramXlmhttp.open("PUT", gBASE_URL + "/" + paramId);
        paramXlmhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXlmhttp.send(JSON.stringify(paramObject));
    }
    // Hàm hiển thị dữ liệu khi update
    function hienThiDuLieuObject(paramXlmhttp) {
        console.log(paramXlmhttp.responseText);
        alert("Đã nhấn Confirm")
    }
    // Hàm thực hiện call Api để cancel đơn hàng
    function callApiCancelOder(paramXlmhttp, paramObject, paramId) {
        paramXlmhttp.open("PUT", gBASE_URL + "/" + paramId);
        paramXlmhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXlmhttp.send(JSON.stringify(paramObject));
    }
    // Hàm hiển thị dữ liệu khi update cancel
    function hienThiDuLieuObjectToCancel(paramXlmhttp) {
        console.log(paramXlmhttp.responseText);
        alert("Đã nhấn Cancel")
    }
    // Hàm gọi Api
    function goiApiObject(paramXlmhttp, paramOderCode) {
        "use strict";
        paramXlmhttp.open("GET", gBASE_URL + "/" + paramOderCode, true);
        paramXlmhttp.send();
    }
    // Hàm hiển thị dữ liệu
    function hienThiDuLieuOject(paramXlmhttp) {
        // debugger;
        console.log(paramXlmhttp.responseText);
        var vObject = JSON.parse(paramXlmhttp.responseText);
        //  truy vấn và thu thập dữ liệu
        var vOderCode = document.getElementById("inp-ma-don-hang");
        var vKichCo = document.getElementById("select-size");
        var vDuongKinh = document.getElementById("inp-size");
        var vSuon = document.getElementById("inp-suon-nuong");
        var vSalad = document.getElementById("inp-salad");

        var vLoaiPizza = document.getElementById("select-pizza");
        var vIdVourcher = document.getElementById("input-voucher");
        var vIdNuocUong = document.getElementById("select-drink");

        var vSoLuongNuoc = document.getElementById("inp-so-luong-nuoc");
        var vHoTen = document.getElementById("input-ho-ten");

        var vThanhTien = document.getElementById("inp-price");
        var vEmail = document.getElementById("inp-email");
        var vSoDienThoai = document.getElementById("inp-mobile");
        var vDiaChi = document.getElementById("inp-address");
        var vLoiNhan = document.getElementById("input-message");

        var vTrangThai = document.getElementById("inp-status");
        var vNgayTao = document.getElementById("inp-date");
        var vNgayCapNhat = document.getElementById("inp-date-update");
        var vGiamGia = document.getElementById("inp-giam-gia");

        vOderCode.value = vObject.orderCode;
        vKichCo.value = vObject.kichCo;
        vDuongKinh.value = vObject.duongKinh;
        vSuon.value = vObject.suon;
        vSalad.value = vObject.salad;

        vLoaiPizza.value = vObject.loaiPizza;
        vIdVourcher.value = vObject.idVourcher;
        //vIdNuocUong.value = vObject.idLoaiNuocUong;
        // load dữ liệu vào select drink
        loadDataDrinkList(vObject.idLoaiNuocUong);
        vSoLuongNuoc.value = vObject.soLuongNuoc;
        vHoTen.value = vObject.hoTen;

        vThanhTien.value = vObject.thanhTien;
        vEmail.value = vObject.email;
        vSoDienThoai.value = vObject.soDienThoai;
        vDiaChi.value = vObject.diaChi;
        vLoiNhan.value = vObject.loiNhan;

        vTrangThai.value = vObject.trangThai;
        vNgayTao.value = vObject.ngayTao;
        vNgayCapNhat.value = vObject.ngayCapNhat;
        vGiamGia.value = vObject.giamGia;
    }
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList(paramIdDoUong) {
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
        vXhttp.send();
        vXhttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXhttp.responseText); // ghi response text ra console.log
                handleLoadDataToSelectDrink(vXhttp, paramIdDoUong);
            }
        };
    }
    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp, paramIdDoUong) {
        var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
        console.log("array drink list = " + vArrayDrinkList.length);
        //load data to drink select
        var vElementSelectDrink = document.getElementById("select-drink");
        for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
            var vDrinkOptionElement = document.createElement("option");
            vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
            vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
            vElementSelectDrink.appendChild(vDrinkOptionElement);
        }

        // select đúng loại đồ uống trong đơn hàng
        for (var bI = 0; bI < vElementSelectDrink.options.length; bI++) {
            if (vElementSelectDrink.options[bI].value === paramIdDoUong) {
                vElementSelectDrink.value = paramIdDoUong;
            }
        }
    }
  // load dữ liệu vào select drink

</script>

</html>